Bug 155934 - Incorporate patch from the Ice project into devel/mcpp
Summary: Incorporate patch from the Ice project into devel/mcpp
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: Olli Hauer
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2011-03-25 14:40 UTC by Michael Gmelin
Modified: 2011-03-30 19:30 UTC (History)
0 users

See Also:


Attachments
file.diff (2.97 KB, patch)
2011-03-25 14:40 UTC, Michael Gmelin
no flags Details | Diff
mcpp.patch.txt (3.92 KB, text/plain)
2011-03-25 17:09 UTC, Michael Gmelin
no flags Details
file.dat (1 bytes, text/plain; charset=us-ascii)
2011-03-25 17:09 UTC, Michael Gmelin
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Gmelin 2011-03-25 14:40:10 UTC
The Ice project by ZeroC (devel/ice and devel/py-ice) did some patches and security updates for the mcpp preprocessor. Without those patches, important parts of ice are not functioning properly. The patches have been applied to various linux package trees in the past successfully. I got in touch with the author and package maintainer of the devel/mcpp port, but he's currently unable to do any work on the project, but gave his consent to applying the patch:

====
Hello,

I'm very sorry, but I have no time for mcpp now.  I think the Zeroc
patch is correct, and has no undesirable side effect.  So, if someone
make an mcpp package applying the patch, and commit it to FreeBSD or any
other system, I will agree with it.

--
Kiyoshi Matsui, the maintainer of mcpp
===

It should be emphasized, that right now ice is the only port using mcpp and that it's misbehaving in subtle ways if the patch is not applied at runtime. So this is somehow critical.

Fix: Apply the patch attached to this PR and reinstall mcpp:

sudo mkdir -p /usr/ports/devel/mcpp/files
sudo cp patch-mcpp-ice.txt /usr/ports/devel/mcpp/files
sudo portupgrade -f devel/mcpp

It would be good, if this patch could be incorporated into the port skeleton of devel/mcpp directly. The original patch is part of the third party sources tarball found on zeroc.com: http://www.zeroc.com/download/Ice/3.4/ThirdParty-Sources-3.4.1.tar.gz


Patch attached with submission follows:
How-To-Repeat: Run mcpp like this:
mcpp -C << EOF
> test; // comment
> EOF
#line 1 "<stdin>"
// commenttest;

This clearly shows the critical misbehaviour when comments are preserved (that's the way slice2java, slice2py and slice2html are calling mcpp).
Comment 1 Edwin Groothuis freebsd_committer 2011-03-25 14:40:29 UTC
Maintainer of devel/mcpp,

Please note that PR ports/155934 has just been submitted.

If it contains a patch for an upgrade, an enhancement or a bug fix
you agree on, reply to this email stating that you approve the patch
and a committer will take care of it.

The full text of the PR can be found at:
    http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/155934

-- 
Edwin Groothuis via the GNATS Auto Assign Tool
edwin@FreeBSD.org
Comment 2 Edwin Groothuis freebsd_committer 2011-03-25 14:40:31 UTC
State Changed
From-To: open->feedback

Awaiting maintainers feedback (via the GNATS Auto Assign Tool)
Comment 3 Michael Gmelin 2011-03-25 17:09:00 UTC
Please find attached a full patch against the ports tree (Makefile with PORTREVISION bumped etc.) which should apply cleanly against devel/mcpp, so minimal effort required by ports maintainer).
Comment 4 Kiyoshi Matsui 2011-03-26 12:34:05 UTC
I approve the ZeroC patch, and hope that the new package by Michael will
be committed to FreeBSD.  Thanks for spending your time on mcpp
maintainance.

--
Kiyoshi Matsui, the maintainer of mcpp
Comment 5 Mark Linimon freebsd_committer freebsd_triage 2011-03-26 17:06:34 UTC
State Changed
From-To: feedback->open

Maintainer approved.
Comment 6 Olli Hauer freebsd_committer 2011-03-30 19:13:05 UTC
Responsible Changed
From-To: freebsd-ports-bugs->ohauer

I'll take it
Comment 7 dfilter service freebsd_committer 2011-03-30 19:26:51 UTC
ohauer      2011-03-30 18:26:40 UTC

  FreeBSD ports repository

  Modified files:
    devel/mcpp           Makefile 
  Added files:
    devel/mcpp/files     patch-src__internal.H patch-src__main.c 
                         patch-src__support.c patch-src__system.c 
  Log:
   - add patches to fix some security and functionality issues
  
  PR:             ports/155934
  Submitted by:   Michael Gmelin <freebsd _at_ grem.de>
  Approved by:    Kiyoshi MATSUI <kmatsui _at_ t3.rim.or.jp> (maintainer)
  
  Revision  Changes    Path
  1.12      +1 -0      ports/devel/mcpp/Makefile
  1.1       +19 -0     ports/devel/mcpp/files/patch-src__internal.H (new)
  1.1       +11 -0     ports/devel/mcpp/files/patch-src__main.c (new)
  1.1       +20 -0     ports/devel/mcpp/files/patch-src__support.c (new)
  1.1       +21 -0     ports/devel/mcpp/files/patch-src__system.c (new)
_______________________________________________
cvs-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/cvs-all
To unsubscribe, send any mail to "cvs-all-unsubscribe@freebsd.org"
Comment 8 Olli Hauer freebsd_committer 2011-03-30 19:28:56 UTC
State Changed
From-To: open->closed

Committed, Thanks!